SystemOrganization addCategory: #'Alien-MacOSX-Core'!

!Object methodsFor: '*Alien-MacOSX-Core' stamp: 'EstebanLorenzano 2/18/2011 12:06'!
asObjectiveCAlien
	self shouldBeImplemented! !

!Object methodsFor: '*Alien-MacOSX-Core' stamp: 'EstebanLorenzano 2/18/2011 09:10'!
isAlien
	^false! !

Object subclass: #ObjectiveCSmalltalkProxyClass
	instanceVariableNames: 'receiverClass proxyClass callbacks instances'
	classVariableNames: 'SmalltalkProxies'
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

ObjectiveCSmalltalkProxyClass class
	instanceVariableNames: 'callbacks'!

!ObjectiveCSmalltalkProxyClass commentStamp: '<historical>' prior: 0!
IMPORTANT: I deprecate ObjectiveCSmalltalkObjectProxy, which is kept for now as a reference (Also, I'm not sure I'm complete ok)

I'm a proxy between Smalltalk and ObjectiveC classes. For all purposes, it is an ObjectiveC class which method implementations resides in Smalltalk (using Callback mechanism).
You need to define a method using the pragma "objectiveCSignature:", and you need to declare the proper signature using this nomenclature: http://developer.apple.com/library/mac/#documentation/Cocoa/Conceptual/ObjCRuntimeGuide/Articles/ocrtTypeEncodings.html
For example, this nomenclature: 'c@:^v' means: returns a character, receives a void* (Alien) as a parameter.

You can see examples of me in: MacOSXAlertDelegate and MacOSXTableViewDelegate!

ObjectiveCSmalltalkProxyClass class
	instanceVariableNames: 'callbacks'!

!ObjectiveCSmalltalkProxyClass class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/19/2011 13:12'!
classFor: aClass
	^self proxyAt: aClass  ! !

!ObjectiveCSmalltalkProxyClass class methodsFor: 'private' stamp: 'EstebanLorenzano 2/19/2011 11:36'!
createProxyFor: aClass
	^self basicNew 
		initialize: aClass;
		yourself! !

!ObjectiveCSmalltalkProxyClass class methodsFor: 'initialization' stamp: 'EstebanLorenzano 3/7/2011 09:44'!
ensureNotifiedAtStartup
	Smalltalk addToStartUpList: self! !

!ObjectiveCSmalltalkProxyClass class methodsFor: 'initialization' stamp: 'EstebanLorenzano 2/21/2011 17:45'!
initialize 
	super initialize.
	self ensureNotifiedAtStartup.
	self startUp: true. ! !

ObjectiveCSmalltalkProxyClass initialize!

!ObjectiveCSmalltalkProxyClass class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/19/2011 12:55'!
instanceFor: anObject 
	^(self proxyAt: anObject class) newFor: anObject! !

!ObjectiveCSmalltalkProxyClass class methodsFor: 'private' stamp: 'EstebanLorenzano 2/19/2011 12:12'!
proxyAt: aClass
	SmalltalkProxies ifNil: [ SmalltalkProxies := Dictionary new ].
	^SmalltalkProxies 
		at: aClass name
		ifAbsentPut: [ self createProxyFor: aClass ]    ! !

!ObjectiveCSmalltalkProxyClass class methodsFor: 'system startup' stamp: 'EstebanLorenzano 2/19/2011 12:06'!
startUp: resuming 
	resuming 
		ifTrue: [ SmalltalkProxies := nil ]! !

!ObjectiveCSmalltalkProxyClass methodsFor: 'private' stamp: 'EstebanLorenzano 2/19/2011 11:49'!
addMethod: aSelector signature: aString in: theClass
	| callback |
	
	callback := self createCallbackFor: aSelector signature: aString.
	self callbacks add: callback.
	theClass 
		addMethod: aSelector
		signature: aString
		implementation: callback! !

!ObjectiveCSmalltalkProxyClass methodsFor: 'private' stamp: 'EstebanLorenzano 2/19/2011 11:49'!
addMethodPragma: aPragma in: theClass "Alien"
	self 
		addMethod: aPragma method selector 
		signature: aPragma arguments first
		in: theClass ! !

!ObjectiveCSmalltalkProxyClass methodsFor: 'private' stamp: 'EstebanLorenzano 2/19/2011 11:50'!
callbacks 
	^callbacks ifNil: [ callbacks := Set new ]! !

!ObjectiveCSmalltalkProxyClass methodsFor: 'private' stamp: 'EstebanLorenzano 10/26/2016 13:05'!
createCallbackFor: aSelector signature: aString
	^Callback 
		signature: #(void * (*)(void *, void *, ...))
		block: [ :receiver :selector :margs | 
			| return |
			return := (self findInstance: receiver address) receiver
				perform: aSelector 
				withArguments: (ObjectiveCAlien
					argumentListFromMArgs: margs 
					numArgs: aSelector numArgs 
					withSignature: aString).
			self return: return signature: aString ]! !

!ObjectiveCSmalltalkProxyClass methodsFor: 'private' stamp: 'EstebanLorenzano 2/19/2011 14:03'!
findInstance: addressNumber
	^instances detect: [ :each | each proxy addressField = addressNumber ].! !

!ObjectiveCSmalltalkProxyClass methodsFor: 'initialization' stamp: 'EstebanLorenzano 2/19/2011 14:02'!
initialize
	super initialize.
	self installSmalltalkProxyClass.
	instances := WeakSet new.
	proxyClass := self proxyClassName inObjectiveC.	! !

!ObjectiveCSmalltalkProxyClass methodsFor: 'initialization' stamp: 'EstebanLorenzano 2/19/2011 11:37'!
initialize: aClass 
	receiverClass := aClass.
	self initialize.    ! !

!ObjectiveCSmalltalkProxyClass methodsFor: 'private' stamp: 'EstebanLorenzano 2/19/2011 12:04'!
installSmalltalkProxyClass
	"Installs a new SmalltalkProxy class in the system. 
	 ProxyCallbacks  is a class side attribute to keep the callbacks and prevent them from being 
	 garbage collected"
	
	ObjectiveCClass 
		createClassNamed: self proxyClassName
		superclass: 'NSObject' 
		into: [ :theClass :theSuperclass | 
			self flag: #todo.
			"(Pragma allNamed: #objectiveCSignature: in: self receiverClass theMetaClass) 
				do: [ :each | self addMethodPragma: each objectiveC: theClass ]."
			(Pragma allNamed: #objectiveCSignature: in: self receiverClass) 
				do: [ :each | self addMethodPragma: each in: theClass ] ].! !

!ObjectiveCSmalltalkProxyClass methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/19/2011 11:56'!
new 
	^self newFor: nil 		! !

!ObjectiveCSmalltalkProxyClass methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/19/2011 14:01'!
newFor: anObject 
	| newInstance |
	newInstance := (ObjectiveCSmalltalkProxyInstance 
		proxy: proxyClass alloc init 
		receiver: anObject).
	instances add: newInstance.
	^newInstance ! !

!ObjectiveCSmalltalkProxyClass methodsFor: 'printing' stamp: 'EstebanLorenzano 2/19/2011 12:08'!
printOn: aStream 
	aStream nextPutAll: self proxyClassName! !

!ObjectiveCSmalltalkProxyClass methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/19/2011 12:03'!
proxyClass
	^proxyClass! !

!ObjectiveCSmalltalkProxyClass methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/19/2011 12:18'!
proxyClassName
	^'SmalltalkProxyFor', self receiverClass name asString! !

!ObjectiveCSmalltalkProxyClass methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/19/2011 11:30'!
receiverClass 
	^receiverClass! !

!ObjectiveCSmalltalkProxyClass methodsFor: 'private' stamp: 'EstebanLorenzano 1/20/2012 21:16'!
return: anObject signature: aString
	^ObjectiveCAlien returnForCallback: anObject withSignature: aString.! !

Object subclass: #ObjectiveCSmalltalkProxyInstance
	instanceVariableNames: 'proxy receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

!ObjectiveCSmalltalkProxyInstance commentStamp: '<historical>' prior: 0!
I'm an instance of an object living in ObjectiveC and Smalltalk!

!ObjectiveCSmalltalkProxyInstance class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/19/2011 12:44'!
new 
	self error: 'Use #proxy:receiver:'! !

!ObjectiveCSmalltalkProxyInstance class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/19/2011 12:44'!
proxy: anAlien receiver: anObject 
	^self basicNew 
		initializeProxy: anAlien receiver: anObject;
		yourself! !

!ObjectiveCSmalltalkProxyInstance methodsFor: 'initialization' stamp: 'EstebanLorenzano 2/19/2011 12:44'!
initializeProxy: anAlien receiver: anObject 
	self initialize.
	proxy := anAlien.
	receiver := anObject! !

!ObjectiveCSmalltalkProxyInstance methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/19/2011 12:43'!
proxy
	^ proxy! !

!ObjectiveCSmalltalkProxyInstance methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/19/2011 12:43'!
receiver
	^ receiver! !

!Symbol methodsFor: '*Alien-MacOSX-Core' stamp: 'EstebanLorenzano 2/8/2011 17:33'!
asObjectiveCSelector
	^ObjectiveCAlien asObjectiveCSelector: self    ! !

!Callback methodsFor: '*Alien-MacOSX-Core' stamp: 'EstebanLorenzano 10/26/2016 13:05'!
voidstarvoidstarvoidstarRetvoidstar: callbackContext sp: spAlien
	<signature: #(void * (*)(void *, void *, ...))>
	self subclassResponsibility! !

!CallbackForIA32 methodsFor: '*Alien-MacOSX-Core' stamp: 'EstebanLorenzano 10/26/2016 13:05'!
voidstarvoidstarvoidstarRetvoidstar: callbackContext sp: spAlien
	<signature: #(void * (*)(void *, void *, ...))>
	| result |

	result := block
		value: (Alien forPointer: (spAlien unsignedLongAt: 1))
		value: (Alien forPointer: (spAlien unsignedLongAt: 5))
		value: (ObjectiveCMArgs forPointer: (spAlien addressField + 8)).
		
	^result isAlien 
		ifTrue: [ callbackContext wordResult:  result addressField ]
		ifFalse: [ callbackContext wordResult: result ]! !

!String methodsFor: '*Alien-MacOSX-Core' stamp: 'EstebanLorenzano 2/18/2011 09:24'!
asNSString
	| NSString |
	NSString := 'NSString' inObjectiveCFramework: 'Foundation'.
	^self isEmpty
		ifTrue: [NSString string]
		ifFalse: [NSString alloc initWithUTF8String: self isoToUtf8 asAlien pointer]! !

!String methodsFor: '*Alien-MacOSX-Core' stamp: 'EstebanLorenzano 3/7/2011 10:20'!
asObjectiveCAlien 
	^self asNSString! !

!String methodsFor: '*Alien-MacOSX-Core' stamp: 'EstebanLorenzano 2/18/2011 09:24'!
inObjectiveC
	^ObjectiveCClassAlien lookup: self! !

!String methodsFor: '*Alien-MacOSX-Core' stamp: 'EstebanLorenzano 2/18/2011 09:24'!
inObjectiveCFramework: frameworkName "<String> ^<ObjectiveCClassAlien>"
	^ObjectiveCClassAlien lookup: self inFramework: frameworkName! !

!Alien methodsFor: '*Alien-MacOSX-Core' stamp: 'EstebanLorenzano 2/18/2011 08:54'!
asObjectiveCSelector 
	^ObjectiveCSelector new 
		unsignedLongAt: 1 put: (self unsignedLongAt: 1);
		yourself	! !

!Alien methodsFor: '*Alien-MacOSX-Core' stamp: 'EstebanLorenzano 2/18/2011 09:10'!
isAlien 
	^true! !

!Alien methodsFor: '*Alien-MacOSX-Core' stamp: 'EstebanLorenzano 2/8/2011 16:52'!
isObjectiveCNil 
	^(self unsignedLongAt: 1) = 0 ! !

Alien variableByteSubclass: #ObjectiveCAlien
	instanceVariableNames: ''
	classVariableNames: 'ClassSelectorAlien EightByteParameterTypes FourByteParameterTypes MethodTypeCallbackResultMap MethodTypeMap MethodTypeResultMap SelectorTable TypeQualifierCodes TypeQualifiers TypeSizes'
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

!ObjectiveCAlien commentStamp: 'eem 1/7/2008 11:45' prior: 0!
ObjectiveCAliens are references to Objective-C objects.  They transparently forward messages not in their Smalltalk API to their Objective-C objects via  a special doesNotUnderstand: method and relevant Objective-C run-time.!

!ObjectiveCAlien class methodsFor: 'objective-c run-time' stamp: 'EstebanLorenzano 1/21/2012 00:07'!
argumentListFromMArgs: margs "<ObjectiveCMArgs>" numArgs: numArgs "<Integer>" withSignature: signature "<String> ^<Array>"
	| sigStream offset |
	sigStream := (signature copyAfter: $:) readStream.
	offset := 1.
	^(1 to: numArgs) collect: [ :index | 
		| code arg |
		
		 [ TypeQualifiers includes: (code := sigStream next) ] whileTrue.
		  arg := (MethodTypeMap 
			at: code 
			ifAbsent: [self error: 'unknown code in Objective-C signature']) 
			value.
		arg replaceFrom: 1 to: arg dataSize with:  margs startingAt: offset.
		 offset := offset + ((EightByteParameterTypes includes: code) ifTrue: [ 8 ] ifFalse: [ 4 ]).
		 code == $^ ifTrue: [ sigStream next ]. "Ignore next"
		 (MethodTypeResultMap at: code ifAbsent: [ [:thing| thing] ]) value: arg ]! !

!ObjectiveCAlien class methodsFor: 'objective-c run-time' stamp: 'EstebanLorenzano 2/8/2011 18:12'!
asObjectiveCSelector: aSelector
	"Answer an Alien for the Objective-C selector corresponding to aSelector.
	 Support selectors that clash with Smalltalk selectors and varargs methods.

	 Selectors that clash with Smalltalk (e.g. class), if sent would be understood
	 as regular Smalltalk selectors, and hence not forwarded to Objective-C by the
	 doesNotUnderstand: method.  Support thesde by allowing selectors to begin
	 with ``objectiveC'', and stripping this prefix when finding the corresponding
	 Objective-C selector. 

	Smalltalk has no support for varargs, and as of 10.4 the Mac OS X frameworks
	contain no occurrences of the keywork 'va:'.  So support varargs by stripping
	all trailing occurrences of ``va:''"
	^SelectorTable
		at: aSelector
		ifAbsentPut: [ 
			ObjCRuntimeRef uniqueInstance 
				selRegisterName: (self removePrefixAndSuffixes: aSelector) ]! !

!ObjectiveCAlien class methodsFor: 'instance creation' stamp: 'eem 1/7/2008 16:30'!
dataSize
	^4! !

!ObjectiveCAlien class methodsFor: 'objective-c run-time' stamp: 'eem 1/29/2008 11:35'!
encodeSimpleSignature: aString
	"Take a string encoding an Objective-C method signature without argument size or offsets
	 and decorate it with sizes and offsets."
	"ObjectiveCAlien encodeSimpleSignature: '@@::^v'"

	| size offset decoration index prefix ch |
	size := offset := 0.
	decoration := String new writeStream.
	index := 1.
	[TypeQualifiers includes: (ch := aString at: index)] whileTrue: [index := index + 1].
	"Special hack for pointer types."
	ch = $^ ifTrue: [index := index + 1]. "For now handle only a single character following ^"
	prefix := index.
	index := index + 1.
	[index <= aString size] whileTrue:
		[[ch := aString at: index.
		  TypeQualifiers includes: ch] whileTrue: [decoration nextPut: ch. index := index + 1].
		 size := (FourByteParameterTypes includes: ch)
					ifTrue: [4]
					ifFalse:
						[(EightByteParameterTypes includes: ch)
							ifTrue: [8]
							ifFalse: [self error: 'unrecognized or unhandled type character']].
		 index := index + 1.
		 (decoration nextPut: ch) = $^ ifTrue: "Special hack for pointer types."
			[decoration nextPut: (aString at: index). "For now handle only a single character following ^"
			 index := index + 1].
		 decoration print: offset.
		 offset := offset + size].
	^(aString copyFrom: 1 to: prefix), offset printString, (decoration contents)! !

!ObjectiveCAlien class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 10/26/2016 10:31'!
ensureNotifiedAtStartup
	"ObjectiveCAlien needs to be notified at system startup to initialize elements of the Objective-C ABI."
	self ~~ ObjectiveCAlien ifTrue: [^self].
	(Smalltalk classNamed: #SessionManager)
		ifNotNil: [:sessionManagerClass|
			sessionManagerClass default
				registerSystemClassNamed: self name
				atPriority: 60]
		ifNil: [Smalltalk addToStartUpList: self after: FFICallbackThunk]	! !

!ObjectiveCAlien class methodsFor: 'objective-c run-time' stamp: 'eem 1/17/2008 11:44'!
frameworkLibraryNameFor: frameworkName
	^'/System/Library/Frameworks/', frameworkName,
			'.framework/Versions/C/', frameworkName! !

!ObjectiveCAlien class methodsFor: 'class initialization' stamp: 'eem 2/27/2008 16:47'!
initialize
	"self initialize"
	self ensureNotifiedAtStartup.
	self initializeMethodTypeMap.
	self startUp: true! !

ObjectiveCAlien initialize!

!ObjectiveCAlien class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 1/21/2012 15:40'!
initializeMethodTypeMap
	"self initializeMethodTypeMap"
	"ObjectiveCAlien initializeMethodTypeMap"
	"See /usr/include/objc/objc_class.h and
	 The Objective-C 2.0 Programming Language, Ch 12: The Runtime System, sec: Type Encodings."
	MethodTypeMap := IdentityDictionary new: 32.
	MethodTypeMap
		at: $@ "_C_ID"			put: [ObjectiveCAlien new ];
		at: $# "_C_CLASS"		put: [ObjectiveCClassAlien new ];
		at: $: "_C_SEL"			put: [Alien new: 4];
		at: $c "_CHR"			put: [Alien new: 1];
		at: $C "_C_UCHR"		put: [Alien new: 1];
		at: $s "_C_SHT"		put: [Alien new: 2];
		at: $S "_C_USHT"		put: [Alien new: 2];
		at: $i "_C_INT"			put: [Alien new: 4];
		at: $I "_C_UINT"		put: [Alien new: 4];
		at: $l "_C_LNG"			put: [Alien new: 4];
		at: $L "_C_ULNG"		put: [Alien new: 4];
		at: $f "_C_FLT"			put: [Alien new: 4];
		at: $d "_C_DBL"		put: [Alien new: 8];
		"at: $b" "_C_BFLD"		"put: [];"
		at: $v "_C_VOID"		put: nil;
		"at: $?" "_C_UNDEF"	"put: [];"
		at: $^ "_C_PTR"		put: [Alien forPointer: 0];
		at: $* "_CHARPTR"		put: [Alien forPointer: 0];
		"at: $[" "_C_ARY_B"	"put: [];"
		"at: $]" "_C_ARY_E"	"put: [];"
		"at: $(" "_C_UNION_B"	"put: [];"
		"at: $)" "_C_UNION_E"	"put: [];"
		at: ${ "_C_STRUCT_B" 	put: nil.
		"at: $}" "_C_STRUCT_E""put: []."

	FourByteParameterTypes := '@#:cCsSiIlLf^*'.
	EightByteParameterTypes := 'd'.

"#define _C_CONST			'r'
#define _C_IN				'n'
#define _C_INOUT			'N'
#define _C_OUT			'o'
#define _C_BYCOPY		'O'
#define _C_BYREF			'R'
#define _C_ONEWAY		'V'
#define _C_GCINVISIBLE	'!!'
"
	TypeQualifiers := 'nNoOrRV!!'.
	TypeQualifierCodes := TypeQualifiers asByteArray.
					
	MethodTypeResultMap := IdentityDictionary new: 32.
	MethodTypeResultMap
		at: $c "_CHR"			put: [:alien| alien unsignedByteAt: 1];
		at: $C "_C_UCHR"		put: [:alien| alien unsignedByteAt: 1];
		at: $s "_C_SHT"		put: [:alien| alien signedShortAt: 1];
		at: $S "_C_USHT"		put: [:alien| alien unsignedShortAt: 1];
		at: $i "_C_INT"			put: [:alien| alien signedLongAt: 1];
		at: $I "_C_UINT"		put: [:alien| alien unsignedLongAt: 1];
		at: $l "_C_LNG"			put: [:alien| alien signedLongAt: 1];
		at: $L "_C_ULNG"		put: [:alien| alien unsignedLongAt: 1];
		at: $f "_C_FLT"			put: [:alien| alien floatAt: 1];
		at: $d "_C_DBL"		put: [:alien| alien doubleAt: 1].

	MethodTypeCallbackResultMap := IdentityDictionary new: 32.
	MethodTypeCallbackResultMap
		at: $v 					put: [ :value | 0 ] ;
		at: $c "_CHR"			put: [ :value | value asInteger] ;
		at: $C "_C_UCHR"		put: [ :value | value asInteger ];
		at: $s "_C_SHT"		put: [ :value | value asInteger ];
		at: $S "_C_USHT"		put: [ :value | value asInteger ];
		at: $i "_C_INT"			put: [ :value | value asInteger ];
		at: $I "_C_UINT"		put: [ :value | value asInteger ];
		at: $l "_C_LNG"			put: [ :value | value asInteger ];
		at: $L "_C_ULNG"		put: [ :value | value asInteger ];
		at: $f "_C_FLT"			put: [ :value | value asFloat ];
		at: $d "_C_DBL"		put: [ :value | value asFloat ].

	TypeSizes := IdentityDictionary new: 32.
	TypeSizes
		at: $c "_CHR"			put: 4;
		at: $C "_C_UCHR"		put: 4;
		at: $s "_C_SHT"		put: 4;
		at: $S "_C_USHT"		put: 4;
		at: $i "_C_INT"			put: 4;
		at: $I "_C_UINT"		put: 4;
		at: $l "_C_LNG"			put: 4;
		at: $L "_C_ULNG"		put: 4;
		at: $f "_C_FLT"			put: 4;
		at: $d "_C_DBL"		put: 8;
		at: $^					put: 4.
! !

!ObjectiveCAlien class methodsFor: 'objective-c run-time' stamp: 'eem 2/12/2008 16:58'!
lookup: globalOrClassName "<String>" inFramework: frameworkName "<String> ^<ObjectiveCClassAlien | ObjectiveCClassAlien | nil>"
	"Looks up a global or a class and answers a suitable Alien.
	 If receiver is ObjectiveCAlien result is an ObjectiveCAlien for some global variable (e.g. NSApp).
	 If receiver is ObjectiveCClassAlien result is an ObjectiveCClassAlien for some class (e.g. NSApplication).
	 i.e. the client must know whether they're asking for a global or a class."
	^self
		lookup: globalOrClassName
		inLibrary: (self frameworkLibraryNameFor: frameworkName)! !

!ObjectiveCAlien class methodsFor: 'private' stamp: 'EstebanLorenzano 2/8/2011 18:12'!
removePrefixAndSuffixes: aSelector 
	"Remove the prefixes and sufixes added to a selector for make it compatible with ObjectiveC. 
	 For example: objectiveCclass will call the objC method #class, not thos one. 
	 and printf: aString va: 'some1' va: 'some2' will call printf with corresponding varargs"
	| selectorString stringAlien objectiveCSelector |
	
	selectorString := aSelector asString.
	
	"Remove prefix"
	selectorString := (selectorString beginsWith: 'objectiveC')
		ifTrue: [ selectorString copyFrom: 11 to: aSelector size ]
		ifFalse: [ selectorString ].
	
	"Remove suffixes (for var args)"
	[selectorString endsWith: 'va:'] 
		whileTrue: [ selectorString := selectorString copyFrom: 1 to: selectorString size - 3 ].
		
	^selectorString! !

!ObjectiveCAlien class methodsFor: 'objective-c run-time' stamp: 'EstebanLorenzano 2/18/2011 11:36'!
returnForCallback: anObject withSignature: signature "<String> ^<Alien>"
	^(MethodTypeCallbackResultMap 
		at: (signature first)
		ifAbsent: [ [ :thing | thing ] ]) 
			value: anObject. 
	! !

!ObjectiveCAlien class methodsFor: 'objective-c run-time' stamp: 'EstebanLorenzano 2/19/2011 23:07'!
returnStructSizeForMethodTypes: methodTypes "<char * Alien> ^<Character>"
	"Answer the return size of an Objective-C method given an Alien for its method_types."
	| returnType types typeStream size |
	
	self flag: #todo. "This method maybe needs to be optimized. It depends on the access to structs in 
	the system, which can be big... easiest way is to cache the returnType, size and skips the full parse
	and matching of types"
	
	returnType := (methodTypes strcpy copyUpToLast: $}) allButFirst.
	types := ((returnType subStrings: '{}') collect: [ :each | each copyAfterLast: $= ])
		inject: String new 
		into: [ :all :each | all, each ].
		
	size := 0.
	typeStream := types readStream.
	[ typeStream atEnd ] 
		whileFalse: [ 
			| type |
			type := typeStream next. 
			size := size + (TypeSizes at: type) value.
			type = $^ ifTrue: [ typeStream next ] ].
	^size! !

!ObjectiveCAlien class methodsFor: 'objective-c run-time' stamp: 'EstebanLorenzano 1/13/2011 12:28'!
returnTypeCharacterForMethodTypes: methodTypes "<char * Alien> ^<Character>"
	"Answer the return type of an Objective-C method given an Alien for its method_types."
	| index code |
	index := 1.
	[ TypeQualifierCodes includes: (code := methodTypes unsignedByteAt: index) ] 
		whileTrue: [ index := index + 1 ].
	^Character value: code! !

!ObjectiveCAlien class methodsFor: 'system startup' stamp: 'EstebanLorenzano 3/7/2011 09:45'!
startUp: resuming
	(resuming and: [Smalltalk os platformName = 'Mac OS'])
		ifFalse: [^ self].

	SelectorTable := Dictionary new 
! !

!ObjectiveCAlien class methodsFor: 'objective-c run-time' stamp: 'eem 2/12/2008 22:02'!
valueOfDatum: global "<String>" inFramework: frameworkName "<String> ^<ObjectiveCClassAlien | nil>"
	"Fetches the value of a global and answers an ObjectiveCAlien."
	^self forPointer: ((self
						lookup: global
						inLibrary: (self frameworkLibraryNameFor: frameworkName))
							unsignedLongAt: 1)! !

!ObjectiveCAlien methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/4/2011 18:11'!
descriptionString 
	^self description UTF8String strcpy! !

!ObjectiveCAlien methodsFor: 'message forwarding' stamp: 'EstebanLorenzano 2/18/2011 22:54'!
doesNotUnderstand: aMessage
	| method returnTypeCharacter result |
	method := self objectiveCMethodForSelectorAlien: aMessage selector.
	method isNil 
		ifTrue: [
		 "Might also check if selector is not already forward: and if
		  so try sending forward: of the selector and arguments?"
		 ^super doesNotUnderstand: aMessage].
	
	returnTypeCharacter := self class returnTypeCharacterForMethodTypes: method methodTypes.
	"If MethodTypeMap doesn't include returnTypeCharacter then we haven't
	implemented handling that return type yet."
	result := (MethodTypeMap at: returnTypeCharacter) value.
	"Structure types are a special case... they need to be answered as C Heap Aliens"
	returnTypeCharacter = ${
		ifTrue: [ 
			result := Alien newGC: (self class returnStructSizeForMethodTypes: method methodTypes).
			method implementation
				primFFICallResult: nil
				withArguments: {result pointer. self. method rawSelector}, aMessage arguments ]
		ifFalse: [
			result := method implementation
				primFFICallResult: result
				withArguments: {self. method rawSelector}, aMessage arguments ].
		
	"If it returns void, we adopt it to Smalltalk style and answer self"
	^returnTypeCharacter = $v 
		ifTrue: [ self ]
		ifFalse: 	[ (MethodTypeResultMap at: returnTypeCharacter ifAbsent: [^result]) value: result ]! !

!ObjectiveCAlien methodsFor: 'coercing' stamp: 'eem 2/7/2008 09:01'!
id
	"Answer the receiver's id. This coerces direct, pointer and indirect ObjectiveC objects correctly."
	^self addressField! !

!ObjectiveCAlien methodsFor: 'accessing' stamp: 'eem 2/7/2008 16:23'!
isa
	| address |
	^(address := self unsignedLongAt: 1) ~= 0 ifTrue:
		[ObjectiveCClassAlien forPointer: ((Alien forPointer: address) unsignedLongAt: 1)]! !

!ObjectiveCAlien methodsFor: 'attic' stamp: 'EstebanLorenzano 1/20/2012 22:08'!
objectiveCClass
	"Obsolete; see isa.  But kept for reference."
	^self objCMsgSendAlien
		primFFICallResult: ObjectiveCAlien newGC
		with: self
		with: #objectiveCclass asObjectiveCSelector! !

!ObjectiveCAlien methodsFor: 'objective-c run-time' stamp: 'EstebanLorenzano 2/17/2011 17:26'!
objectiveCMethodForSelectorAlien: aSelector
	^ObjCRuntimeRef uniqueInstance 
		class: self isa 
		getInstanceMethod: aSelector! !

!ObjectiveCAlien methodsFor: 'as yet unclassified' stamp: 'CarlaGriggio 7/8/2013 11:41'!
release
	self flag: #todo.
	"Is it correct to avoid freeing pointers of objective-c?"! !

ObjectiveCAlien variableByteSubclass: #ObjectiveCClassAlien
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

!ObjectiveCClassAlien commentStamp: 'eem 1/8/2008 09:54' prior: 0!
ObjectiveCAliens are references to Objective-C class objects.  They transparently forward messages not in their Smalltalk API to theirrespective Objective-C class objects as do instances of ObjectiveCAlien.  The difference is due to ObjectiveC's lack of metaclasses.  Hence class methods must be looked up using class_getClassMethod, whereas in ObjectiveCAlien they are looked up using class_getInstanceMethod.!

!ObjectiveCClassAlien class methodsFor: 'objective-c run-time' stamp: 'EstebanLorenzano 2/4/2011 14:40'!
lookup: className
	^ObjCRuntimeRef uniqueInstance objcLookup:  className  ! !

!ObjectiveCClassAlien class methodsFor: 'objective-c run-time' stamp: 'EstebanLorenzano 12/24/2010 08:39'!
lookup: className "<String>" inLibrary: aLibraryName "<String> ^<ObjectiveCClassAlien | nil>"
	"self ensureLoaded: aLibraryName."
	^self lookup: className! !

!ObjectiveCClassAlien methodsFor: 'converting' stamp: 'eem 1/30/2008 14:30'!
asObjectiveCClass
	"Answer a struct objc_class object (ObjectiveCClass) for the receivers class."
	^ObjectiveCClass atAddress: (self unsignedLongAt: 1)! !

!ObjectiveCClassAlien methodsFor: 'objective-c run-time' stamp: 'EstebanLorenzano 2/4/2011 14:10'!
objectiveCMethodForSelectorAlien: aSelector
	^ObjCRuntimeRef uniqueInstance 
		class: self 
		getClassMethod: aSelector! !

Alien variableByteSubclass: #ObjectiveCMArgs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

!ObjectiveCMArgs commentStamp: '<historical>' prior: 0!
This class's instances are wrappers around Objective-C margs parameters of the forward:: method.,

WARNING!! va_list mangling has changed in gcc 4.4... so this can stop working anytime. !

!ObjectiveCMArgs class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/8/2011 18:44'!
dataSize 
	^4! !

Alien variableByteSubclass: #ObjectiveCMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

!ObjectiveCMethod commentStamp: 'eem 1/7/2008 16:32' prior: 0!
/*
 *  Method Template
 */
typedef struct objc_method *Method;

struct objc_method {
    SEL method_name;
    char *method_types;
    IMP method_imp;
};
!

!ObjectiveCMethod class methodsFor: 'instance creation' stamp: 'eem 1/7/2008 16:31'!
dataSize
	"typedef struct objc_method *Method;

	struct objc_method {
	    SEL method_name;
	    char *method_types;
	    IMP method_imp;
	};"

	^12! !

!ObjectiveCMethod methodsFor: 'accessing' stamp: 'eem 1/30/2008 14:34'!
implementation
	^Alien forPointer: (self unsignedLongAt: 9)! !

!ObjectiveCMethod methodsFor: 'accessing' stamp: 'eem 1/30/2008 14:55'!
methodTypes
	^Alien forPointer: (self unsignedLongAt: 5)! !

!ObjectiveCMethod methodsFor: 'accessing' stamp: 'eem 1/30/2008 14:34'!
methodTypesString
	^(Alien forPointer: (self unsignedLongAt: 5)) strcpy! !

!ObjectiveCMethod methodsFor: 'accessing' stamp: 'eem 1/29/2008 11:08'!
rawSelector
	^self unsignedLongAt: 1! !

!ObjectiveCMethod methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/3/2011 16:42'!
selector
	^ObjectiveCSelector forPointer: (self unsignedLongAt: 1)! !

!ObjectiveCMethod methodsFor: 'instance initalization' stamp: 'eem 1/29/2008 15:03'!
selector: selector "<ObjectiveCAlien>" methodTypes: string "<char * Alien>" implementation: functionPointer "<id (*IMP)(id, SEL, ...) Alien> ^<self>"
	self unsignedLongAt: 1 put: (selector unsignedLongAt: 1).
	self unsignedLongAt: 5 put: string address.
	self unsignedLongAt: 9 put: (functionPointer unsignedLongAt: 1)! !

Alien variableByteSubclass: #ObjectiveCMethodList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

!ObjectiveCMethodList commentStamp: 'eem 1/10/2008 18:27' prior: 0!
struct objc_method_list {
    struct objc_method_list *obsolete;

    int method_count;
#ifdef __alpha__
    int space;
#endif
    struct objc_method method_list[1];  /* variable length structure */
};
!

!ObjectiveCMethodList class methodsFor: 'instance creation' stamp: 'eem 1/29/2008 13:09'!
dataSize
	^20
	
"struct objc_method_list {
    struct objc_method_list *obsolete;

    int method_count;
#ifdef __alpha__
    int space;
#endif
    struct objc_method method_list[1];  /* variable length structure */
};
"! !

!ObjectiveCMethodList methodsFor: 'accessing' stamp: 'eem 1/29/2008 12:01'!
method: oneRelativeIndex "<Integer>" put: method "<ObjectiveCMethod>"
	| methodsBaseIndex |
	methodsBaseIndex := 9 + (oneRelativeIndex - 1 * ObjectiveCMethod dataSize).
	self
		unsignedLongAt: methodsBaseIndex put: (method unsignedLongAt: 1);
		unsignedLongAt: methodsBaseIndex + 4 put: (method unsignedLongAt: 5);
		unsignedLongAt: methodsBaseIndex + 8 put: (method unsignedLongAt: 9).! !

!ObjectiveCMethodList methodsFor: 'accessing' stamp: 'eem 1/28/2008 12:45'!
methodCount
	^self signedLongAt: 5! !

!ObjectiveCMethodList methodsFor: 'accessing' stamp: 'eem 1/29/2008 11:57'!
methodCount: anInteger
	self signedLongAt: 5 put: anInteger! !

Alien variableByteSubclass: #ObjectiveCObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

!ObjectiveCObject commentStamp: 'eem 1/24/2008 13:04' prior: 0!
Access to the raw structure of an ObjectiveC object.  Do not confuse this with ObjectiveCAlien, wich is a Smalltalk proxy for an ObjectiveC object.  This is an indirect object (a struct, if you like); ObjectiveCAlien is a direct pointer to an object (a reference to an Objective-C object).

@interface Object
{
    Class isa;  /* A pointer to the instance's class structure */
}

Effectively:
struct objc_object {
    struct objc_class *isa;
};
!

ObjectiveCObject variableByteSubclass: #ObjectiveCClass
	instanceVariableNames: ''
	classVariableNames: 'CLSCLASS CLSMETA'
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

!ObjectiveCClass commentStamp: 'eem 1/10/2008 18:07' prior: 0!
/*
 *  Class Template
 */
struct objc_class {
    struct objc_class *isa;
    struct objc_class *super_class;
    const char *name;
    long version;
    long info;
    long instance_size;
    struct objc_ivar_list *ivars;

    struct objc_method_list **methodLists;

    struct objc_cache *cache;
    struct objc_protocol_list *protocols;
};
!

!ObjectiveCClass class methodsFor: 'class creation' stamp: 'EstebanLorenzano 2/4/2011 14:38'!
createClassNamed: className "<String>" superclass: superclassName "<String>" into: binaryBlock "<[:class <ObjectiveCClass> :metaclass <ObjectiveCClass>| <^Type>]> ^<Type>"
	^ObjCRuntimeRef uniqueInstance 
		objcAddClassNamed: className 
		superclass: superclassName   
		into: binaryBlock! !

!ObjectiveCClass class methodsFor: 'instance creation' stamp: 'eem 1/10/2008 18:07'!
dataSize
	^40

"/*
 *  Class Template
 */
struct objc_class {
    struct objc_class *isa;
    struct objc_class *super_class;
    const char *name;
    long version;
    long info;
    long instance_size;
    struct objc_ivar_list *ivars;

    struct objc_method_list **methodLists;

    struct objc_cache *cache;
    struct objc_protocol_list *protocols;
};"! !

!ObjectiveCClass methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/4/2011 14:28'!
addMethod: aSelector signature: aString implementation: aCallback
	ObjCRuntimeRef uniqueInstance 
		class: self	
		addMethod: aSelector 
		implementation: aCallback
		signature: aString! !

!ObjectiveCClass methodsFor: 'coercing' stamp: 'eem 1/30/2008 14:30'!
asObjectiveCClassAlien
	"Answer an ObjectiveC object for the receiver's struct objc_class."
	^ObjectiveCClassAlien atAddress: self address! !

!ObjectiveCClass methodsFor: 'accessing' stamp: 'eem 1/10/2008 22:00'!
info: anInteger 
	self signedLongAt: 17 put: anInteger! !

!ObjectiveCClass methodsFor: 'accessing' stamp: 'eem 1/10/2008 22:19'!
instanceSize
	^self signedLongAt: 21! !

!ObjectiveCClass methodsFor: 'accessing' stamp: 'eem 1/10/2008 22:19'!
instanceSize: anInteger 
	self signedLongAt: 21 put: anInteger! !

!ObjectiveCClass methodsFor: 'accessing' stamp: 'eem 1/10/2008 22:17'!
methodLists: anAlien "<ObjectiveCMethodLists>" 
	self unsignedLongAt: 29 put: anAlien address! !

!ObjectiveCClass methodsFor: 'accessing' stamp: 'eem 1/30/2008 14:24'!
objectiveCname "^<Alien char *>"
	^Alien
		atAddress: (self unsignedLongAt: 9)
		dataSize: (self strlenThroughPointerAt: 9) + 1! !

!ObjectiveCClass methodsFor: 'accessing' stamp: 'eem 1/10/2008 22:05'!
objectiveCname: anAlienOrString
	self unsignedLongAt: 9 put: anAlienOrString asAlien address! !

!ObjectiveCClass methodsFor: 'accessing' stamp: 'eem 1/30/2008 14:30'!
superclass
	| address |
	^(address := self unsignedLongAt: 5) = 0 ifFalse:
		[ObjectiveCClass atAddress: address]! !

!ObjectiveCClass methodsFor: 'accessing' stamp: 'eem 1/10/2008 21:48'!
superclass: anAlienOrNil
	self unsignedLongAt: 5 put: (anAlienOrNil isNil ifTrue: [0] ifFalse: [anAlienOrNil address])! !

!ObjectiveCObject class methodsFor: 'instance creation' stamp: 'eem 1/24/2008 13:01'!
dataSize
	^4! !

!ObjectiveCObject methodsFor: 'coercing' stamp: 'eem 2/7/2008 09:05'!
id
	"Answer the receiver's id. This coerces direct, pointer and indirect ObjectiveC objects correctly."
	^self addressField! !

!ObjectiveCObject methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/3/2011 12:49'!
isa
	| address |
	(address := self unsignedLongAt: 1) = 0 
		ifTrue: [ self error: 'Invalid address' ].
	^ObjectiveCClass atAddress: address! !

!ObjectiveCObject methodsFor: 'accessing' stamp: 'eem 2/7/2008 09:06'!
isa: anObjectiveCClassAlienOrNil
	self unsignedLongAt: 1 put: anObjectiveCClassAlienOrNil id! !

Alien variableByteSubclass: #ObjectiveCSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

!ObjectiveCSelector class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/8/2011 17:12'!
dataSize
	"SEL"
	^4! !

!ObjectiveCSelector methodsFor: 'converting' stamp: 'EstebanLorenzano 2/18/2011 09:09'!
asObjectiveCSelector 
	^self! !

!ObjectiveCSelector methodsFor: 'converting' stamp: 'EstebanLorenzano 2/8/2011 18:21'!
asSmalltalkSelector
	"Assume the receiver is an Alien for a SEL.  Answer its correspondng Smaltalk selector, or raise an error."
	| resultAlien |
	resultAlien := (ObjCRuntimeRef uniqueInstance selGetName: self).
	resultAlien isObjectiveCNil
		ifTrue: [ self error: 'Alien is nil' ].  
	
	^resultAlien strcpy asSymbol! !

!ObjectiveCSelector methodsFor: 'coercing' stamp: 'EstebanLorenzano 1/13/2011 10:58'!
id
	"Answer the receiver's id. This coerces direct, pointer and indirect ObjectiveC objects correctly."
	^self addressField! !

ExternalLibrary subclass: #ObjCRuntimeRef
	instanceVariableNames: 'classGetClassMethodAlien classGetInstanceMethodAlien objCLookUpClassAlien objCMsgSendAlien selRegisterNameAlien selGetNameAlien objcAllocateClassPairAlien objcRegisterClassPairAlien objcAddMethodAlien objcAddClassAlien objcAddMethodsAlien'
	classVariableNames: 'UniqueInstance'
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

!ObjCRuntimeRef class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/4/2011 14:41'!
CLSCLASS 
	^1! !

!ObjCRuntimeRef class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/4/2011 14:41'!
CLSMETA 
	^2! !

!ObjCRuntimeRef class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 2/17/2012 20:32'!
initialize 
	self register.! !

ObjCRuntimeRef initialize!

!ObjCRuntimeRef class methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/20/2012 19:39'!
moduleName
	^'libobjc.dylib'! !

!ObjCRuntimeRef class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/20/2012 19:41'!
new 
	self error: 'Use #uniqueInstance'! !

!ObjCRuntimeRef class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 2/17/2012 20:33'!
register
	Smalltalk addToStartUpList: self! !

!ObjCRuntimeRef class methodsFor: 'system startup' stamp: 'EstebanLorenzano 2/17/2012 20:32'!
startUp: resuming 
	resuming 
		ifTrue: [ UniqueInstance := nil ].! !

!ObjCRuntimeRef class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/20/2012 19:41'!
uniqueInstance 
	^UniqueInstance ifNil: [ UniqueInstance := super new ]! !

!ObjCRuntimeRef class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 2/17/2012 20:33'!
unregister
	Smalltalk removeFromStartUpList: self! !

!ObjCRuntimeRef methodsFor: 'private' stamp: 'EstebanLorenzano 1/20/2012 19:40'!
alienMethodNamed: aString 
	^Alien lookup: aString inLibrary: self name.! !

!ObjCRuntimeRef methodsFor: 'library' stamp: 'EstebanLorenzano 2/15/2011 10:30'!
class: anObjectiveCClass addMethod: aSelector implementation: aCallback signature: aString
	^self isRuntime2 
		ifTrue: [ 
			self 
				rt2Class: anObjectiveCClass 
				addMethod: aSelector asObjectiveCSelector
				implementation: aCallback thunk
				signature: aString asAlien ]
		ifFalse: [ 
			self 
				rt1Class: anObjectiveCClass 
				addMethod: aSelector asObjectiveCSelector
				implementation: aCallback thunk
				signature: aString asAlien ]
! !

!ObjCRuntimeRef methodsFor: 'library' stamp: 'EstebanLorenzano 2/4/2011 14:21'!
class: anObjectiveCClass getClassMethod: aSelector 
	| pointer |

	pointer := self classGetClassMethodAlien
		primFFICallResult: (Alien new: 4)
		with: anObjectiveCClass 
		with: aSelector asObjectiveCSelector.

	(pointer := pointer unsignedLongAt: 1) = 0 
		ifTrue: [ self error: 'Invalid selector ', aSelector asString ].
	
	^ObjectiveCMethod atAddress: pointer! !

!ObjCRuntimeRef methodsFor: 'library' stamp: 'EstebanLorenzano 2/4/2011 14:22'!
class: anObjectiveCClass getInstanceMethod: aSelector
	| pointer address |
	
	pointer := self classGetInstanceMethodAlien 
		primFFICallResult: (Alien new: 4)
		with: anObjectiveCClass
		with: aSelector asObjectiveCSelector.
			
	(address := pointer unsignedLongAt: 1) = 0 
		ifTrue: [ self error: 'Invalid selector ', aSelector asString ].
	
	^ObjectiveCMethod atAddress: address! !

!ObjCRuntimeRef methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/24/2010 08:31'!
classGetClassMethodAlien
	^ classGetClassMethodAlien! !

!ObjCRuntimeRef methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/24/2010 08:31'!
classGetInstanceMethodAlien
	^ classGetInstanceMethodAlien! !

!ObjCRuntimeRef methodsFor: 'private' stamp: 'EstebanLorenzano 2/4/2011 15:07'!
createClassDefinitionOnRuntimeOneNamed: className "<String>" superclassName: superclassName "<String> ^<nil | Array of: ObjectiveCClass>"
	"Objective-C 1.0 version of creating a class (10.4 and prior).
	 See CreateClassDefinition in`Objective-C 1 Runtime Reference'.
	 In Leopard, which has the Objective-C 2.0 run-time, we can simply use objc_allocateClassPair."
	| supercls newClass newMetaclass rootClass |

	(supercls := ObjectiveCClassAlien lookup: superclassName) ifNil: [^nil].
	supercls := supercls asObjectiveCClass.
	(ObjectiveCClassAlien lookup: className) ifNotNil: [^nil].

	rootClass := supercls.
	[rootClass superclass notNil] whileTrue:
		[rootClass := rootClass superclass].

	newClass := self newC.
	newMetaclass := self newC.
	newClass isa: newMetaclass.
	newMetaclass isa: rootClass isa.
	newClass info: self class CLSCLASS.
	newMetaclass info: self class CLSMETA.
	newClass objectiveCname: className.
	newMetaclass  objectiveCname: newClass objectiveCname.
	newClass methodLists: ((Alien newC: 4) signedLongAt: 1 put: -1; yourself).
	newMetaclass methodLists: ((Alien newC: 4) signedLongAt: 1 put: -1; yourself).
	newClass superclass: supercls.
	newMetaclass superclass: supercls isa.
	newClass instanceSize: supercls instanceSize.
	newMetaclass instanceSize: newMetaclass superclass instanceSize.

	self objcAddClassAlien 
		primFFICallResult: nil
		with: newClass address.

	^Array with: newClass with: newMetaclass! !

!ObjCRuntimeRef methodsFor: 'initialization' stamp: 'EstebanLorenzano 2/2/2011 15:37'!
initialize 
	super initialize.

	"access operations"
	classGetClassMethodAlien := self alienMethodNamed: 'class_getClassMethod'.
	classGetInstanceMethodAlien := self alienMethodNamed: 'class_getInstanceMethod'.
	objCLookUpClassAlien := self alienMethodNamed: 'objc_lookUpClass'.
	objCMsgSendAlien := self alienMethodNamed: 'objc_msgSend'.
	selRegisterNameAlien := self alienMethodNamed: 'sel_registerName'.
	selGetNameAlien := self alienMethodNamed: 'sel_getName'.
	
	"adding classes/methods operations"
	objcAllocateClassPairAlien := self alienMethodNamed: 'objc_allocateClassPair'.
	objcRegisterClassPairAlien := self alienMethodNamed: 'objc_registerClassPair'.
	objcAddMethodAlien := self alienMethodNamed: 'class_addMethod'.
	objcAddClassAlien := self alienMethodNamed: 'objc_addClass'.
	objcAddMethodsAlien := self alienMethodNamed: 'class_addMethods'.! !

!ObjCRuntimeRef methodsFor: 'testing' stamp: 'EstebanLorenzano 2/4/2011 14:20'!
isRuntime2 
	^self objcAddMethodAlien notNil! !

!ObjCRuntimeRef methodsFor: 'library' stamp: 'EstebanLorenzano 2/3/2011 17:49'!
methodGetTypeEncoding: anObjectiveCMethod
	| charPointerAlien alien |
	alien := self alienMethodNamed: 'method_getTypeEncoding'.
	charPointerAlien := alien 
		primFFICallResult: (Alien new: 4) 
		with: anObjectiveCMethod.
	
	^charPointerAlien addressField ~= 0
		ifTrue: [ charPointerAlien strcpy ] 
		ifFalse: [ nil ] ! !

!ObjCRuntimeRef methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/24/2010 08:31'!
objCLookUpClassAlien
	^ objCLookUpClassAlien! !

!ObjCRuntimeRef methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/24/2010 08:31'!
objCMsgSendAlien
	^ objCMsgSendAlien! !

!ObjCRuntimeRef methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/28/2010 09:32'!
objcAddClassAlien
	^ objcAddClassAlien! !

!ObjCRuntimeRef methodsFor: 'library' stamp: 'EstebanLorenzano 2/4/2011 14:40'!
objcAddClassNamed: className "<String>" superclass: superclassName "<String>" into: binaryBlock "<[:class <ObjectiveCClass> :metaclass <ObjectiveCClass>| <^Type>]> ^<Type>"

	^self isRuntime2
		ifTrue: [ self rt2CreateClassNamed: className superclass: superclassName into: binaryBlock ]
		ifFalse: [ self rt1CreateClassNamed: className superclass: superclassName into: binaryBlock ].

! !

!ObjCRuntimeRef methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/28/2010 09:32'!
objcAddMethodAlien
	^ objcAddMethodAlien! !

!ObjCRuntimeRef methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/28/2010 09:32'!
objcAddMethodsAlien
	^ objcAddMethodsAlien! !

!ObjCRuntimeRef methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/28/2010 09:32'!
objcAllocateClassPairAlien
	^ objcAllocateClassPairAlien! !

!ObjCRuntimeRef methodsFor: 'library' stamp: 'EstebanLorenzano 2/4/2011 14:40'!
objcLookup: className "<String> ^<ObjectiveCClassAlien | nil>"
	| classAlien stringAlien |
	self objCLookUpClassAlien 
		primFFICallResult: (classAlien := ObjectiveCClassAlien new)
		with: (stringAlien := className asAlien) pointer.
	stringAlien free.
	^(classAlien unsignedLongAt: 1) ~= 0 ifTrue: [classAlien]! !

!ObjCRuntimeRef methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/28/2010 09:32'!
objcRegisterClassPairAlien
	^ objcRegisterClassPairAlien! !

!ObjCRuntimeRef methodsFor: 'private' stamp: 'EstebanLorenzano 2/4/2011 15:07'!
rt1Class: anObjectiveCClass "<Alien>" addMethod: selector "<Alien>" implementation: functionPointer "<FFICallbackThunk|Alien>" signature: signature "<String>" 
	
	| methodList |
	self flag: #fixme. 
	self error: 'Not working'.
	methodList := ObjectiveCMethodList newC
						methodCount: 1;
						method: 1 put: (ObjectiveCMethod new
											selector: selector
											methodTypes: (ObjectiveCAlien encodeSimpleSignature: signature) asAlien
											implementation: functionPointer).
	self  objcAddMethodsAlien 
		primFFICallResult: nil
		with: anObjectiveCClass address
		with: methodList address! !

!ObjCRuntimeRef methodsFor: 'private' stamp: 'EstebanLorenzano 2/4/2011 14:43'!
rt1CreateClassNamed: className superclass: superclassName into: binaryBlock
	| classPairOrNil |
	"objc_allocateClasPair unavailable.  use the 1.0 run-time"
	classPairOrNil := self 
		createClassDefinitionOnRuntimeOneNamed: className
		superclassName: superclassName.
	^classPairOrNil isNil
		ifTrue: [ self error: 'Could not create class' ]
		ifFalse: [ binaryBlock valueWithArguments: classPairOrNil ]! !

!ObjCRuntimeRef methodsFor: 'private' stamp: 'EstebanLorenzano 2/4/2011 15:08'!
rt2Class: anObjectiveCClass "<Alien>" addMethod: selectorAlien "<Alien>" implementation: functionPointer "<FFICallbackThunk|Alien>" signature: signatureAlien "<Alien>" 
	| boolAlien |
	self objcAddMethodAlien 
		primFFICallResult: (boolAlien := Alien new: 4)
		with: anObjectiveCClass pointer "It's a Class, I need to pass a pointer to it"
		with: selectorAlien
		with: functionPointer
		with: signatureAlien pointer. "It's a char*, I need to pass a pointer to it"

	(boolAlien unsignedLongAt: 1) = 0 
		ifTrue: [ self error: 'class_addMethod failed' ]! !

!ObjCRuntimeRef methodsFor: 'private' stamp: 'EstebanLorenzano 2/4/2011 15:08'!
rt2CreateClassNamed: className superclass: superclassName into: binaryBlock
	"Use the 2.0 run-time to create an ObjectiveC class"
	| classAlien classNameAlien |

	"Create class"
	classAlien := self objcAllocateClassPairAlien
		primFFICallResult: ObjectiveCClassAlien new
		with: (ObjectiveCClassAlien lookup: superclassName)
		with: (classNameAlien := className asAlien) pointer
		with: 0.
	classNameAlien free.
	
	"Assert the class was created"
	classAlien addressField = 0
		ifTrue: [ self error: 'Could not create class' ].
			
	"Execute body creation"
	binaryBlock 
		value: classAlien asObjectiveCClass 
		value: classAlien isa asObjectiveCClass.
	
	"Register class"
	self objcRegisterClassPairAlien 
		primFFICallResult: (Alien new: 4)
		with: classAlien.
			
	^classAlien! !

!ObjCRuntimeRef methodsFor: 'library' stamp: 'EstebanLorenzano 2/4/2011 15:06'!
selGetName: anObjectiveCSelector 
	^self selGetNameAlien
		primFFICallResult: (Alien forPointer: 0)
		with: anObjectiveCSelector! !

!ObjCRuntimeRef methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/24/2010 08:31'!
selGetNameAlien
	^ selGetNameAlien! !

!ObjCRuntimeRef methodsFor: 'library' stamp: 'EstebanLorenzano 2/4/2011 15:08'!
selRegisterName: aSelector 
	| objectiveCSelector stringAlien |
	
	stringAlien := aSelector asString asAlien.
	objectiveCSelector := self selRegisterNameAlien
		primFFICallResult: ObjectiveCSelector new
		with: stringAlien pointer.
	stringAlien free.

	^objectiveCSelector
	! !

!ObjCRuntimeRef methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/24/2010 08:31'!
selRegisterNameAlien
	^ selRegisterNameAlien! !

ObjectiveCAlien initialize!

ObjectiveCSmalltalkProxyClass initialize!

ObjCRuntimeRef initialize!
